﻿//ALL CLASSES NEED THIS
package {
	//WE NEED THESE IMPORTED FOR THE PROGRAM TO RUN
	import flash.display.MovieClip;
	import flash.events.*;

	//THIS MAKES EACH SHOT ACT AS A MOVIECLIP
	public class DestructBlock extends MovieClip {

		//VARIABLES

		//Defining _root for use as the root of the game
		private var _root:Object;

		//THIS WILL RUN FOR EVERY SHOT ADDED TO THE GAME
		public function DestructBlock() {
			//ADDING EVENT THAT WILL ONLY RUN ONCE
			// (WHEN THE OBJECT IS ADDED)
			addEventListener(Event.ADDED, beginClass);

			//EVENT THAT WILL RUN EVERY FRAME
			addEventListener(Event.ENTER_FRAME, eFrame);
		}


		//SETTING _root AS THE ROOT
		private function beginClass(event:Event):void {
			_root=MovieClip(root);
		}


		//ON EVERY FRAME
		private function eFrame(event:Event):void {

			//checking if it is touching any bullets
			//we will have to run a for loop because there will be multiple bullets
			for (var i:int = 0; i<_root.bulletContainer.numChildren; i++) {
				//numChildren is just the amount of movieclips within 
				//the bulletContainer.

				//we define a variable that will be the bullet that we are currently
				//hit testing.
				var bulletTarget:MovieClip=_root.bulletContainer.getChildAt(i);

				//now we hit test
				if (hitTestObject(bulletTarget)) {
					//remove this from the stage if it touches a bullet
					removeEventListener(Event.ENTER_FRAME, eFrame);
					this.parent.removeChild(this);
					//also remove the bullet and its listeners
					_root.bulletContainer.removeChild(bulletTarget);
					bulletTarget.removeListeners();
					//up the score
					_root.score+=1;

				}
			}


			//CHECK FOR GAMEOVER
			if (_root.gameOver) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}
				//CHECK FOR GAMEOVER
			if (_root.resetting) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}
		}
		

		//HOW TO REMOVE LISTENERS WITH A SHORT CALL
		public function removeListeners():void {
			this.removeEventListener(Event.ENTER_FRAME, eFrame);
		}
	}
}