//This is the basic skeleton that all classes must have
package {
	//we have to import certain display objects and events
	import flash.display.MovieClip;
	import flash.events.*;
	//this just means that EnemyA will act like a MovieClip
	public class EnemyA extends MovieClip {
		//VARIABLES
		//this will act as the root of the document
		//so we can easily reference it within the class
		private var _root:Object;
		//how quickly the Enemy will move
		private var airSpeed:int=10;
		private var AIRSPEEDMAX:int=12;
		
		private var shootCounter:int=0;
		private var shootTime:int=36;
		//this function will run every time the Enemy is added
		//to the stage
		public function EnemyA() {
			//adding events to this class
			//functions that will run only when the MC is added
			addEventListener(Event.ADDED, beginClass);
			//functions that will run on enter frame
			addEventListener(Event.ENTER_FRAME, eFrame);
		}
		private function beginClass(event:Event):void {
			_root=MovieClip(root);
		}
		private function eFrame(event:Event):void {
			shootCounter++;
			//checking if game is over
			if (_root.gameOver) {
				removeEventListener(Event.ENTER_FRAME, eFrame);
				this.parent.removeChild(this);
			}
			
				if (shootCounter>=shootTime) {
				var newShot = new EnemyBullet();
				newShot.y=this.y+_root.enemyContainer.y;
				newShot.x=this.x+_root.enemyContainer.x;
				_root.addChild(newShot);
				shootCounter = 0;

				
			}
			this.y+=airSpeed;
			if (checkForContact()) {
				if (airSpeed>0) {
					for (var i:int = 0; i<airSpeed; i++) {
						if (checkForContact()) {
							this.y-=1;
						}
					}

				} else {
					for (var i:int = 0; i>airSpeed; i--) {
						if (checkForContact()) {
							this.y+=1;
						}
					}
					airSpeed=0;
				}
			}
				//CHECK FOR GAMEOVER
			if (_root.resetting) {
				//REMOVE LISTENERS
				removeEventListener(Event.ENTER_FRAME, eFrame);
				//REMOVE SELF FROM STAGE
				this.parent.removeChild(this);
			}

			if (airSpeed<AIRSPEEDMAX) {
				airSpeed++;
			}

		}
		public function removeListeners():void {
			removeEventListener(Event.ENTER_FRAME, eFrame);
		}

		private function checkForContact():Boolean {
			for (var i:int = 0; i<_root.LevelContainer.numChildren; i++) {
				//numChildren is just the amount of movieclips within 
				//the LevelContainer.

				//we define a variable that will be the ground that we are currently
				//hit testing.
				var levelTarget=_root.LevelContainer.getChildAt(i);

				//now we hit test
				if (this.hitTestObject(levelTarget)) {
					return true;
				}
			}
			return false;
		}
	}
}